'use strict';

exports.__esModule = true;
function createThunkMiddleware(errorHandler, extraArgument) {
  return function (_ref) {
    var dispatch = _ref.dispatch,
        getState = _ref.getState;
    return function (next) {
      return function (action) {
        if (typeof action === 'function') {
          try {
            return action(dispatch, getState, extraArgument);
          } catch (err) {
            errorHandler(err, getState(), action, dispatch);
            return err;
          }
        }

        try {
          return next(action);
        } catch (err) {
          errorHandler(err, getState(), action, dispatch);
          return err;
        }
      };
    };
  };
}

exports['default'] = createThunkMiddleware;